Index: /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90
===================================================================
--- /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 7952)
+++ /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 7953)
@@ -55,5 +55,5 @@
    USE ldfdyn         ! lateral viscosity setting      (ldfdyn_init routine)
    USE ldftra         ! lateral diffusivity setting    (ldftra_init routine)
-   USE zdfini         ! vertical physics setting          (zdf_init routine)
+!!gm   USE zdfphy         ! vertical physics manager      (zdf_phy_init routine)
    USE trdini         ! dyn/tra trends initialization     (trd_init routine)
    USE asminc         ! assimilation increments     
@@ -429,5 +429,5 @@
       IF( ln_ctl        )   CALL prt_ctl_init   ! Print control
       
-      CALL diurnal_sst_bulk_init            ! diurnal sst
+      CALL diurnal_sst_bulk_init             ! diurnal sst
       IF ( ln_diurnal ) CALL diurnal_sst_coolskin_init   ! cool skin   
       
@@ -455,14 +455,8 @@
                             CALL     sbc_init   ! surface boundary conditions (including sea-ice)
                             CALL     bdy_init   ! Open boundaries initialisation
+
       !                                      ! Ocean physics
-      !                                         ! Vertical physics
-                            CALL     zdf_init      ! namelist read
-                            CALL zdf_bfr_init      ! bottom friction
-      IF( lk_zdfric     )   CALL zdf_ric_init      ! Richardson number dependent Kz
-      IF( lk_zdftke     )   CALL zdf_tke_init      ! TKE closure scheme
-      IF( lk_zdfgls     )   CALL zdf_gls_init      ! GLS closure scheme
-      IF( lk_zdftmx     )   CALL zdf_tmx_init      ! tidal vertical mixing
-!!gm      IF( ln_zdfddm     )   CALL zdf_ddm_init      ! double diffusive mixing
-         
+                            CALL zdf_phy_init   ! Vertical physics
+                                     
       !                                         ! Lateral physics
                             CALL ldf_tra_init      ! Lateral ocean tracer physics
@@ -470,5 +464,5 @@
                             CALL ldf_dyn_init      ! Lateral ocean momentum physics
 
-      !                                         ! Active tracers
+      !                                      ! Active tracers
                             CALL tra_qsr_init      ! penetrative solar radiation qsr
                             CALL tra_bbc_init      ! bottom heat flux
@@ -479,5 +473,5 @@
                             CALL tra_zdf_init      ! vertical mixing and after tracer fields
 
-      !                                         ! Dynamics
+      !                                      ! Dynamics
       IF( lk_c1d        )   CALL dyn_dmp_init      ! internal momentum damping
                             CALL dyn_adv_init      ! advection (vector or flux form)
@@ -511,5 +505,5 @@
       IF( ln_diaobs     )   CALL dia_obs( nit000 - 1 )   ! Observation operator for restart
 
-      !                                         ! Assimilation increments
+      !                                      ! Assimilation increments
       IF( lk_asminc     )   CALL asm_inc_init   ! Initialize assimilation increments
       IF(lwp) WRITE(numout,*) 'Euler time step switch is ', neuler
Index: /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/step.F90
===================================================================
--- /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 7952)
+++ /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/step.F90	(revision 7953)
@@ -74,7 +74,7 @@
       !!              -8- Outputs and diagnostics
       !!----------------------------------------------------------------------
-      INTEGER ::   ji,jj,jk ! dummy loop indice
-      INTEGER ::   indic    ! error indicator if < 0
-      INTEGER ::   kcall    ! optional integer argument (dom_vvl_sf_nxt)
+      INTEGER ::   ji, jj, jk   ! dummy loop indice
+      INTEGER ::   indic        ! error indicator if < 0
+      INTEGER ::   kcall        ! optional integer argument (dom_vvl_sf_nxt)
       !! ---------------------------------------------------------------------
 #if defined key_agrif
@@ -125,40 +125,7 @@
                          CALL bn2    ( tsn, rab_n, rn2  ) ! now    Brunt-Vaisala frequency
 
-      !
       !  VERTICAL PHYSICS
-                         CALL zdf_bfr( kstp )         ! bottom friction (if quadratic)
-      !                                               ! Vertical eddy viscosity and diffusivity coefficients
-      IF( lk_zdfric  )   CALL zdf_ric ( kstp )             ! Richardson number dependent Kz
-      IF( lk_zdftke  )   CALL zdf_tke ( kstp )             ! TKE closure scheme for Kz
-      IF( lk_zdfgls  )   CALL zdf_gls ( kstp )             ! GLS closure scheme for Kz
-      IF( ln_zdfqiao )   CALL zdf_qiao( kstp )             ! Qiao vertical mixing 
-      !
-      IF( lk_zdfcst  ) THEN                                ! Constant Kz (reset avt, avm[uv] to the background value)
-         avt (:,:,:) = rn_avt0 * wmask (:,:,:)
-         avm (:,:,:) = rn_avm0 * wmask (:,:,:)
-         avmu(:,:,:) = rn_avm0 * wumask(:,:,:)
-         avmv(:,:,:) = rn_avm0 * wvmask(:,:,:)
-      ENDIF
-      !
-      IF( ln_rnf_mouth ) THEN                         ! increase diffusivity at rivers mouths
-         DO jk = 2, nkrnf   ;   avt(:,:,jk) = avt(:,:,jk) + 2._wp * rn_avt_rnf * rnfmsk(:,:) * tmask(:,:,jk)   ;   END DO
-      ENDIF
-      !
-      IF( ln_zdfevd  )   CALL zdf_evd( kstp )         ! enhanced vertical eddy diffusivity
-      !
-      IF( ln_zdfddm  ) THEN                           ! double diffusive mixing
-                         CALL zdf_ddm( kstp )
-      ELSE                                            ! avs=avt
-         DO jk = 2, jpkm1   ;   avs(:,:,jk) = avt(:,:,jk)   ;   END DO
-      ENDIF
-      !
-      IF( lk_zdftmx  )   CALL zdf_tmx( kstp )         ! tidal vertical mixing
-
-                         CALL zdf_mxl( kstp )         ! mixed layer depth
-
-                                                      ! write TKE or GLS information in the restart file
-      IF( lrst_oce .AND. lk_zdftke )   CALL tke_rst( kstp, 'WRITE' )
-      IF( lrst_oce .AND. lk_zdfgls )   CALL gls_rst( kstp, 'WRITE' )
-      !
+                         CALL zdf_phy( kstp )         ! vertical physics update (bfr, avt, avs, avm + MLD)
+
       !  LATERAL  PHYSICS
       !
Index: /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/step_oce.F90
===================================================================
--- /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/step_oce.F90	(revision 7952)
+++ /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/step_oce.F90	(revision 7953)
@@ -63,4 +63,6 @@
    USE ldftra           ! lateral eddy diffusive coef.     (ldf_tra routine)
 
+   USE zdfphy         ! vertical physics manager      (zdf_phy_init routine)
+!!gm to be suppressed
    USE zdftmx           ! tide-induced vertical mixing     (zdf_tmx routine)
    USE zdfbfr           ! bottom friction                  (zdf_bfr routine)
@@ -72,4 +74,5 @@
    USE zdfmxl           ! Mixed-layer depth                (zdf_mxl routine)
    USE zdfqiao          !Qiao module wave induced mixing   (zdf_qiao routine)
+!!gm end
 
    USE step_diu        ! Time stepping for diurnal sst
Index: /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/TRP/trcdmp.F90
===================================================================
--- /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/TRP/trcdmp.F90	(revision 7952)
+++ /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/TRP/trcdmp.F90	(revision 7953)
@@ -121,5 +121,5 @@
                      DO jj = 2, jpjm1
                         DO ji = fs_2, fs_jpim1   ! vector opt.
-                           IF( avt(ji,jj,jk) <= 5.e-4_wp )  THEN 
+                           IF( avs(ji,jj,jk) <= 5.e-4_wp )  THEN 
                               tra(ji,jj,jk,jn) = tra(ji,jj,jk,jn) + restotr(ji,jj,jk) * ( ztrcdta(ji,jj,jk) - trb(ji,jj,jk,jn) )
                            ENDIF
Index: /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90
===================================================================
--- /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 7952)
+++ /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 7953)
@@ -4,6 +4,7 @@
    !! Ocean Passive tracers : vertical diffusive trends 
    !!=====================================================================
-   !! History :  9.0  ! 2005-11 (G. Madec)  Original code
+   !! History :  9.0  ! 2005-11  (G. Madec)  Original code
    !!       NEMO 3.0  ! 2008-01  (C. Ethe, G. Madec)  merge TRC-TRA 
+   !!            4.0  ! 2017-04  (G. Madec)  remove the explicit case
    !!----------------------------------------------------------------------
 #if defined key_top
@@ -11,6 +12,5 @@
    !!   'key_top'                                                TOP models
    !!----------------------------------------------------------------------
-   !!   trc_zdf      : update the tracer trend with the lateral diffusion
-   !!   trc_zdf_ini  : initialization, namelist read, and parameters control
+   !!   trc_zdf      : update the tracer trend with the vertical diffusion
    !!----------------------------------------------------------------------
    USE trc           ! ocean passive tracers variables
@@ -27,14 +27,5 @@
 
    PUBLIC   trc_zdf         ! called by step.F90 
-   PUBLIC   trc_zdf_ini     ! called by nemogcm.F90 
    
-   !                                        !!** Vertical diffusion (nam_trczdf) **
-   LOGICAL , PUBLIC ::   ln_trczdf_exp       !: explicit vertical diffusion scheme flag
-   INTEGER , PUBLIC ::   nn_trczdf_exp       !: number of sub-time step (explicit time stepping)
-
-   INTEGER ::   nzdf = 0               ! type vertical diffusion algorithm used
-      !                                ! defined from ln_zdf...  namlist logicals)
-   !! * Substitutions
-#  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/TOP 3.7 , NEMO Consortium (2015)
@@ -48,5 +39,6 @@
       !!                  ***  ROUTINE trc_zdf  ***
       !!
-      !! ** Purpose :   compute the vertical ocean tracer physics.
+      !! ** Purpose :   compute the vertical ocean tracer physics using
+      !!              an implicit time-stepping scheme.
       !!---------------------------------------------------------------------
       INTEGER, INTENT( in ) ::  kt      ! ocean time-step index
@@ -54,19 +46,13 @@
       INTEGER               ::  jk, jn
       CHARACTER (len=22)    :: charout
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) ::   ztrtrd   ! 4D workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk,jptra) ::   ztrtrd   ! 4D workspace
       !!---------------------------------------------------------------------
       !
       IF( nn_timing == 1 )  CALL timing_start('trc_zdf')
       !
-      IF( l_trdtrc )  THEN
-         CALL wrk_alloc( jpi, jpj, jpk, jptra, ztrtrd )
-         ztrtrd(:,:,:,:)  = tra(:,:,:,:)
-      ENDIF
-
-      SELECT CASE ( nzdf )                       ! compute lateral mixing trend and add it to the general trend
-      CASE ( 0 ) ;  CALL tra_zdf_exp( kt, nittrc000, 'TRC', r2dttrc, nn_trczdf_exp, trb, tra, jptra )    !   explicit scheme 
-      CASE ( 1 ) ;  CALL tra_zdf_imp( kt, nittrc000, 'TRC', r2dttrc,                trb, tra, jptra )    !   implicit scheme          
-      END SELECT
-
+      IF( l_trdtrc )   ztrtrd(:,:,:,:)  = tra(:,:,:,:)
+      !
+      CALL tra_zdf_imp( kt, nittrc000, 'TRC', r2dttrc, trb, tra, jptra )    !   implicit scheme          
+      !
       IF( l_trdtrc )   THEN                      ! save the vertical diffusive trends for further diagnostics
          DO jn = 1, jptra
@@ -76,10 +62,10 @@
             CALL trd_tra( kt, 'TRC', jn, jptra_zdf, ztrtrd(:,:,:,jn) )
          END DO
-         CALL wrk_dealloc( jpi, jpj, jpk, jptra, ztrtrd )
       ENDIF
       !                                          ! print mean trends (used for debugging)
       IF( ln_ctl )   THEN
-         WRITE(charout, FMT="('zdf ')") ;  CALL prt_ctl_trc_info(charout)
-                                           CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
+         WRITE(charout, FMT="('zdf ')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
       END IF
       !
@@ -87,64 +73,4 @@
       !
    END SUBROUTINE trc_zdf
-
-
-   SUBROUTINE trc_zdf_ini
-      !!----------------------------------------------------------------------
-      !!                 ***  ROUTINE trc_zdf_ini  ***
-      !!
-      !! ** Purpose :   Choose the vertical mixing scheme
-      !!
-      !! ** Method  :   Set nzdf from ln_zdfexp
-      !!      nzdf = 0   explicit (time-splitting) scheme (ln_trczdf_exp=T)
-      !!           = 1   implicit (euler backward) scheme (ln_trczdf_exp=F)
-      !!      NB: The implicit scheme is required when using : 
-      !!             - rotated lateral mixing operator
-      !!             - TKE, GLS vertical mixing scheme
-      !!----------------------------------------------------------------------
-      INTEGER ::  ios                 ! Local integer output status for namelist read
-      !!
-      NAMELIST/namtrc_zdf/ ln_trczdf_exp  , nn_trczdf_exp
-      !!----------------------------------------------------------------------
-      !
-      REWIND( numnat_ref )             ! namtrc_zdf in reference namelist 
-      READ  ( numnat_ref, namtrc_zdf, IOSTAT = ios, ERR = 905)
-905   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_zdf in reference namelist', lwp )
-      !
-      REWIND( numnat_cfg )             ! namtrc_zdf in configuration namelist 
-      READ  ( numnat_cfg, namtrc_zdf, IOSTAT = ios, ERR = 906 )
-906   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_zdf in configuration namelist', lwp )
-      IF(lwm) WRITE ( numont, namtrc_zdf )
-      !
-      IF(lwp) THEN                     ! Control print
-         WRITE(numout,*)
-         WRITE(numout,*) '   Namelist namtrc_zdf : set vertical diffusion  parameters'
-         WRITE(numout,*) '      time splitting / backward scheme ln_trczdf_exp = ', ln_trczdf_exp
-         WRITE(numout,*) '      number of time step              nn_trczdf_exp = ', nn_trczdf_exp
-      ENDIF
-
-      !                                ! Define the vertical tracer physics scheme
-      IF( ln_trczdf_exp ) THEN   ;   nzdf = 0     ! explicit scheme
-      ELSE                       ;   nzdf = 1     ! implicit scheme
-      ENDIF
-
-      !                                ! Force implicit schemes
-      IF( ln_trcldf_iso              )   nzdf = 1      ! iso-neutral lateral physics
-      IF( ln_trcldf_hor .AND. ln_sco )   nzdf = 1      ! horizontal lateral physics in s-coordinate
-#if defined key_zdftke || defined key_zdfgls 
-                                         nzdf = 1      ! TKE or GLS physics       
-#endif
-      IF( ln_trczdf_exp .AND. nzdf == 1 )  & 
-         CALL ctl_stop( 'trc_zdf : If using the rotated lateral mixing operator or TKE, GLS vertical scheme ', &
-            &           '          the implicit scheme is required, set ln_trczdf_exp = .false.' )
-
-      IF(lwp) THEN
-         WRITE(numout,*)
-         WRITE(numout,*) 'trc:zdf_ctl : vertical passive tracer physics scheme'
-         WRITE(numout,*) '~~~~~~~~~~~'
-         IF( nzdf ==  0 )   WRITE(numout,*) '              Explicit time-splitting scheme'
-         IF( nzdf ==  1 )   WRITE(numout,*) '              Implicit (euler backward) scheme'
-      ENDIF
-      !
-   END SUBROUTINE trc_zdf_ini
    
 #else
Index: /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90
===================================================================
--- /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 7952)
+++ /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/oce_trc.F90	(revision 7953)
@@ -101,8 +101,5 @@
 
    !* vertical diffusion *
-   USE zdf_oce , ONLY :   avt        =>   avt         !: vert. diffusivity coef. at w-point for temp  
-# if defined key_zdfddm
-   USE zdfddm  , ONLY :   avs        =>   avs         !: salinity vertical diffusivity coeff. at w-point
-# endif
+   USE zdf_oce , ONLY :   avs        =>   avs         !: vert. diffusivity coef. for salinity (w-point)
 
    !* mixing & mixed layer depth *
Index: /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/trc.F90
===================================================================
--- /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 7952)
+++ /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/trc.F90	(revision 7953)
@@ -126,9 +126,6 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::  vn_tm       !: j-horizontal velocity average     [m/s]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::  tsn_tm      !: t/s average     [m/s]
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::  avt_tm      !: vertical diffusivity coeff. at  w-point   [m2/s]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::  avs_tm      !: vertical diffusivity coeff. at  w-point   [m2/s]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::  rhop_tm     !: 
-# if defined key_zdfddm
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::  avs_tm      !: vertical double diffusivity coeff. at w-point   [m/s]
-# endif
 #if defined key_trabbl
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::  ahu_bbl_tm  !: u-, w-points
@@ -154,5 +151,5 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:,:) ::  tsn_temp
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::  un_temp,vn_temp,wn_temp     !: hold current values of avt, un, vn, wn
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::  avt_temp, rhop_temp     !: hold current values of avt, un, vn, wn
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::  avs_temp, rhop_temp     !: hold current values of avt, un, vn, wn
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:)     ::  sshn_temp, sshb_temp, ssha_temp, rnf_temp,h_rnf_temp
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::  hdivn_temp, rotn_temp
@@ -165,7 +162,4 @@
 #endif
    !
-# if defined key_zdfddm
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:)   ::  avs_temp      !: salinity vertical diffusivity coeff. at w-point   [m/s]
-# endif
    !
    CHARACTER(len=20), PUBLIC, ALLOCATABLE,  SAVE,  DIMENSION(:)   ::  cn_trc_dflt          ! Default OBC condition for all tracers
Index: /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/trcini.F90
===================================================================
--- /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 7952)
+++ /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 7953)
@@ -196,5 +196,4 @@
       USE trcadv , ONLY:  trc_adv_ini
       USE trcldf , ONLY:  trc_ldf_ini
-      USE trczdf , ONLY:  trc_zdf_ini
       USE trcrad , ONLY:  trc_rad_ini
       !
@@ -205,5 +204,5 @@
                        CALL  trc_adv_ini          ! advection
                        CALL  trc_ldf_ini          ! lateral diffusion
-                       CALL  trc_zdf_ini          ! vertical diffusion
+                       !                          ! vertical diffusion: always implicit time stepping scheme
                        CALL  trc_rad_ini          ! positivity of passive tracers 
       !
@@ -223,16 +222,16 @@
       !!----------------------------------------------------------------------
       !
-      ! Initialisation of tracers Initial Conditions
-      IF( ln_trcdta )      CALL trc_dta_ini(jptra)
-
-      ! Initialisation of tracers Boundary Conditions
-      IF( ln_my_trc )     CALL trc_bc_ini(jptra)
-
-      IF( ln_rsttr ) THEN
+
+      IF( ln_trcdta )   CALL trc_dta_ini( jptra )      ! set initial tracers values
+
+      IF( ln_my_trc )   CALL trc_bc_ini ( jptra )      ! set tracers Boundary Conditions
+
+
+      IF( ln_rsttr ) THEN              ! restart from a file
         !
-        CALL trc_rst_read              ! restart from a file
+        CALL trc_rst_read
         !
-      ELSE
-        ! Initialisation of tracer from a file that may also be used for damping
+      ELSE                             ! Initialisation of tracer from a file that may also be used for damping
+!!gm BUG ?   if damping and restart, what's happening ?
         IF( ln_trcdta .AND. nb_trcdta > 0 ) THEN
             ! update passive tracers arrays with input data read from file
@@ -250,5 +249,5 @@
                   ENDIF
                ENDIF
-            ENDDO
+            END DO
             !
         ENDIF
@@ -262,4 +261,5 @@
    END SUBROUTINE trc_ini_state
 
+
    SUBROUTINE top_alloc
       !!----------------------------------------------------------------------
Index: /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/trcsub.F90
===================================================================
--- /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/trcsub.F90	(revision 7952)
+++ /branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/TOP_SRC/trcsub.F90	(revision 7953)
@@ -84,8 +84,5 @@
           tsn_tm  (:,:,:,jp_sal) = tsn_tm  (:,:,:,jp_sal) + tsn  (:,:,:,jp_sal) * e3t_n(:,:,:)  
           rhop_tm (:,:,:)        = rhop_tm (:,:,:)        + rhop (:,:,:)        * e3t_n(:,:,:)  
-          avt_tm  (:,:,:)        = avt_tm  (:,:,:)        + avt  (:,:,:)        * e3w_n(:,:,:)  
-# if defined key_zdfddm
           avs_tm  (:,:,:)        = avs_tm  (:,:,:)        + avs  (:,:,:)        * e3w_n(:,:,:)  
-# endif
          IF( l_ldfslp ) THEN
             uslp_tm (:,:,:)      = uslp_tm (:,:,:)        + uslp (:,:,:)
@@ -122,8 +119,5 @@
          tsn_temp   (:,:,:,:)    = tsn   (:,:,:,:)
          rhop_temp  (:,:,:)      = rhop  (:,:,:)    
-         avt_temp   (:,:,:)      = avt   (:,:,:)
-# if defined key_zdfddm
          avs_temp   (:,:,:)      = avs   (:,:,:)
-# endif
          IF( l_ldfslp ) THEN
             uslp_temp  (:,:,:)   = uslp  (:,:,:)   ;   wslpi_temp (:,:,:)   = wslpi (:,:,:)
@@ -161,8 +155,5 @@
          tsn_tm   (:,:,:,jp_sal) = tsn_tm  (:,:,:,jp_sal) + tsn  (:,:,:,jp_sal) * e3t_n(:,:,:)  
          rhop_tm (:,:,:)         = rhop_tm (:,:,:)        + rhop (:,:,:)        * e3t_n(:,:,:)  
-         avt_tm   (:,:,:)        = avt_tm  (:,:,:)        + avt  (:,:,:)        * e3w_n(:,:,:)  
-# if defined key_zdfddm
          avs_tm   (:,:,:)        = avs_tm  (:,:,:)        + avs  (:,:,:)        * e3w_n(:,:,:)  
-# endif
          IF( l_ldfslp ) THEN
             uslp_tm  (:,:,:)     = uslp_tm (:,:,:)        + uslp (:,:,:) 
@@ -245,9 +236,6 @@
                   tsn  (ji,jj,jk,jp_sal) = tsn_tm  (ji,jj,jk,jp_sal) * z1_ne3t
                   rhop (ji,jj,jk)        = rhop_tm (ji,jj,jk)        * z1_ne3t
-!!gm : BUG? ==>> for avt & avs I don't understand the division by e3w
-                  avt  (ji,jj,jk)        = avt_tm  (ji,jj,jk)        * z1_ne3w
-# if defined key_zdfddm
+!!gm : BUG ==>> for avs I don't understand the division by e3w
                   avs  (ji,jj,jk)        = avs_tm  (ji,jj,jk)        * z1_ne3w
-# endif
                END DO
             END DO
@@ -297,8 +285,5 @@
       rhop_tm (:,:,:)        = rhop (:,:,:)        * e3t_n(:,:,:)  
 !!gm : BUG? ==>> for avt & avs I don't understand the division by e3w
-      avt_tm  (:,:,:)        = avt  (:,:,:)        * e3w_n(:,:,:)  
-# if defined key_zdfddm
       avs_tm  (:,:,:)        = avs  (:,:,:)        * e3w_n(:,:,:)  
-# endif
       IF( l_ldfslp ) THEN
          wslpi_tm(:,:,:)     = wslpi(:,:,:)
@@ -354,8 +339,5 @@
       tsn   (:,:,:,:) =  tsn_temp   (:,:,:,:)
       rhop  (:,:,:)   =  rhop_temp  (:,:,:)
-      avt   (:,:,:)   =  avt_temp   (:,:,:)
-# if defined key_zdfddm
       avs   (:,:,:)   =  avs_temp   (:,:,:)
-# endif
       IF( l_ldfslp ) THEN
          wslpi (:,:,:)=  wslpi_temp (:,:,:)
@@ -396,8 +378,5 @@
          tsn_tm  (:,:,:,jp_sal) = tsn  (:,:,:,jp_sal) * e3t_n(:,:,:)  
          rhop_tm (:,:,:)        = rhop (:,:,:)        * e3t_n(:,:,:)  
-         avt_tm  (:,:,:)        = avt  (:,:,:)        * e3w_n(:,:,:)  
-# if defined key_zdfddm
          avs_tm  (:,:,:)        = avs  (:,:,:)        * e3w_n(:,:,:)  
-# endif
       IF( l_ldfslp ) THEN
          uslp_tm (:,:,:)        = uslp (:,:,:)
@@ -534,5 +513,5 @@
       !
       ALLOCATE( un_temp(jpi,jpj,jpk)        ,  vn_temp(jpi,jpj,jpk)  ,   &
-         &      wn_temp(jpi,jpj,jpk)        ,  avt_temp(jpi,jpj,jpk) ,   &
+         &      wn_temp(jpi,jpj,jpk)        ,                            &
          &      rhop_temp(jpi,jpj,jpk)      ,  rhop_tm(jpi,jpj,jpk) ,   &
          &      sshn_temp(jpi,jpj)          ,  sshb_temp(jpi,jpj) ,      &
@@ -548,10 +527,7 @@
          &      fr_i_temp(jpi,jpj)          ,  fr_i_tm(jpi,jpj) ,        &
          &      wndm_temp(jpi,jpj)          ,  wndm_tm(jpi,jpj) ,        &
-# if defined key_zdfddm
          &      avs_tm(jpi,jpj,jpk)         ,  avs_temp(jpi,jpj,jpk) ,   &
-# endif
          &      hdivn_temp(jpi,jpj,jpk)     ,  hdivb_temp(jpi,jpj,jpk),  &
          &      un_tm(jpi,jpj,jpk)          ,  vn_tm(jpi,jpj,jpk)  ,     &
-         &      avt_tm(jpi,jpj,jpk)                                ,     &
          &      sshn_tm(jpi,jpj)            ,  sshb_hold(jpi,jpj) ,      &
          &      tsn_tm(jpi,jpj,jpk,2)       ,                            &
